/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.guosen.userActivityStatistical.wrapper;

import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.modules.guosen.activity.entity.Activity;
import org.springblade.modules.guosen.activity.service.IActivityService;
import org.springblade.modules.guosen.loginUser.entity.LoginUser;
import org.springblade.modules.guosen.loginUser.service.ILoginUserService;
import org.springblade.modules.guosen.loginUser.vo.LoginWebVO;
import org.springblade.modules.guosen.rank.service.RankService;
import org.springblade.modules.guosen.userActivityStatistical.entity.UserActivityStatistical;
import org.springblade.modules.guosen.userActivityStatistical.vo.UserActivityStatisticalVO;

import java.util.Objects;

/**
 * 包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2021-06-20
 */
public class UserActivityStatisticalWrapper extends BaseEntityWrapper<UserActivityStatistical, UserActivityStatisticalVO>  {

	private RankService rankService;
	private IActivityService activityService;

	public UserActivityStatisticalWrapper(RankService rankService) {
		this.rankService = rankService;
	}

	public UserActivityStatisticalWrapper(IActivityService activityService) {
		this.activityService = activityService;
	}

	public static UserActivityStatisticalWrapper build(RankService rankService) {
		return new UserActivityStatisticalWrapper(rankService);
	}
	public static UserActivityStatisticalWrapper build(IActivityService activityService) {
		return new UserActivityStatisticalWrapper(activityService);
	}


	@Override
	public UserActivityStatisticalVO entityVO(UserActivityStatistical userActivityStatistical) {
		UserActivityStatisticalVO userActivityStatisticalVO = Objects.requireNonNull(BeanUtil.copy(userActivityStatistical, UserActivityStatisticalVO.class));

		if (userActivityStatisticalVO != null && rankService != null) {
			Long activityId = userActivityStatisticalVO.getActivityId();
			Long userId = userActivityStatisticalVO.getUserId();
			LoginWebVO loginWebVO = rankService.rank(activityId.toString(), userId.toString(), 0);
			userActivityStatisticalVO.setLoginWebVO(loginWebVO);
		}

		if (userActivityStatisticalVO != null && activityService != null) {
			Activity activity = activityService.getById(userActivityStatisticalVO.getActivityId());
			userActivityStatisticalVO.setActivityName(activity.getName());
		}

		return userActivityStatisticalVO;
	}

}
